
#ifdef WIN32
    #include <winsock2.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include "uSQLcClient.h"



char *gQuery;
int gQlen;
int reccount;



int Hcallback(void *tag, int argc, char **argv, char **ColName,int fsizes[]){
int i;

    *(gQuery+gQlen)=0; // put the NULL back after send
    if(reccount==0)printf("<p><H3>Result of query:</H3><p>%s<p><hr>",gQuery);
    reccount++;
    for(i=0;i<argc;i++)printf("%s=%s<p>",ColName[i],argv[i]);
    printf("<hr>");
}

int Mcallback(void *tag, int argc, char **argv, char **ColName,int fsizes[]){
int i;

    if(reccount==0){
    	for(i=0;i<argc;i++)
            printf(":H%i:%i %s\r",i+1,strlen(ColName[i]),ColName[i]);
        printf(":R\r\n");
    }
    reccount++;
    for(i=0;i<argc;i++){
        if(argv[i]==0)
            printf("!\r");
        else
            printf("%s\r",argv[i]);
    }
}


void ecallback(char *err){
	printf(":Err : %s\r",err);
}



// Expands HTTP GET Esc codes
int escGet(char *in, int *len){
char *cur,*end;
int val;

    cur=in;
    end=in+(*len);

    while(cur<end){
        if(*cur=='%'){
            if(sscanf(cur+1,"%2X",&val)!=1)return -1;
            *in=val;
            in++;
            cur+=3;
            len-=2;
        }
        else if(*cur=='&'){
        	*cur=' ';
        	cur++,in++;
        }
        else
        *in++=*cur++;
    }
    *in=0;
    return 0;
}


char *salloc(size_t sz){
char *mm;
    mm=malloc(sz);
    if(!mm){
    	fprintf(stderr,"\nMemory allocation error\n");
    	exit(1);
    }
    return mm;
}

int main(int argc,char *argv[]){
int qlen;
char *qstring,*qsrc,user[64],pass[64],mode;
uSQLCdb *udb;
int ErrCode;
#ifdef WIN32
WORD vr;
WSADATA ws;

    vr=MAKEWORD(2,0);
    if(WSAStartup(vr,&ws)){
    	fprintf(stderr,"This program requires winsock 2 DLL or higher\n");
    	exit(1);
    }
#endif


		
		printf("Content-type: text/html\r\n\r\n");
        
        qsrc=getenv("QUERY_STRING");
        qlen=strlen(qsrc);
        qstring=salloc(qlen);
        memcpy(qstring,qsrc,qlen+1);
        escGet(qstring,&qlen);
        
        
        sscanf(qstring,"user=%62s pass=%62s mode=%c query=%n",user,pass,&mode,&qlen);
        gQuery=qstring+qlen;
        gQlen=strlen(gQuery);
        
        // to see what your sending as a query
        //printf("<p>%s<p>",qsrc);
        //printf("argc %i  argv %s <p>%s",argc,argv[0],qstring);
        //printf("<p>user %s <p>pass %s <p>mode %c <p>query %s",user,pass,mode,gQuery);
        
        
        
        
        // localhost and port=3002, timeout 5000mS
        udb=uSQLCopen(user,pass,"localhost",3002,5000,&ErrCode);
        if(udb){
            reccount=0;
            if(mode=='h'){
                ErrCode=uSQLCexec(udb,gQuery,Hcallback,NULL,ecallback);
                if(reccount==0){
                    *(gQuery+gQlen)=0;
                    printf("<p><H3>Result of query:</H3><p>%s<p><hr>",gQuery);
                }
            }
            else
                ErrCode=uSQLCexec(udb,gQuery,Mcallback,NULL,ecallback);
            
            
            if(ErrCode!=0)
                printf("\r\n:Err : Execution code %i\r\n:OK\r\n ",ErrCode);
            else
                printf("\r\n:OK\r\n ");
        }
        else printf("\r\n:Err : Execution code %i\r\n:OK\r\n ",ErrCode);
        
        uSQLCclose(udb);
           
        
abort:
    free(qstring);
        
}
